part of dorm;

class MetadataCache {
  
  //---------------------------------
  //
  // Constructor
  //
  //---------------------------------
  
  const MetadataCache();
  
  //---------------------------------
  //
  // Public methods
  //
  //---------------------------------
  
  void registerTagForProperty(_DormPropertyInfo entry, dynamic reflectee) {
    switch (reflectee.ident) {
      case 'id':
        entry.metadataCache.isId = true;
        entry.metadataCache.insertValue = reflectee.insertValue;
        break;
      case 'transient':
        entry.metadataCache.isTransient = true;
        break;
      case 'notNullable':
        entry.metadataCache.isNullable = false;
        break;
      case 'defaultValue':
        entry.metadataCache.initialValue = reflectee.value;
        break;
      case 'labelField':
        entry.metadataCache.isLabelField = true;
        break;
      case 'immutable':
        entry.metadataCache.isMutable = false;
        break;
      case 'silent':
        entry.metadataCache.isSilent = true;
        break;
      case 'transform':
        entry.metadataCache.transformFrom = reflectee.from;
        entry.metadataCache.transformTo = reflectee.to;
        break;
      case 'generic':
        entry.metadataCache.genericAnnotations = (reflectee as Annotation).params;
        break;
    }
  }
}

//---------------------------------
//
// Internal objects
//
//---------------------------------

class _PropertyMetadataCache {
  
  final String property;
  
  String expectedType;
  bool isId = false;
  bool isTransient = false;
  bool isNullable = true;
  bool isLabelField = false;
  bool isMutable = true;
  bool isSilent = false;
  String transformFrom, transformTo;
  Map<String, dynamic> genericAnnotations;
  
  dynamic insertValue;
  dynamic initialValue;
  
  _PropertyMetadataCache(this.property);
  
  MetadataExternalized _getMetadataExternal() => new MetadataExternalized(
    expectedType,
    isId,
    isTransient,
    isNullable,
    isLabelField,
    isMutable,
    isSilent,
    transformFrom,
    transformTo,
    genericAnnotations);
}

class MetadataExternalized {
  
  final String expectedType;
  final bool isId;
  final bool isTransient;
  final bool isNullable;
  final bool isLabelField;
  final bool isMutable;
  final bool isSilent;
  final String transformFrom, transformTo;
  final Map<String, dynamic> genericAnnotations;
  
  const MetadataExternalized(this.expectedType, this.isId, this.isTransient, this.isNullable, this.isLabelField, this.isMutable, this.isSilent, this.transformFrom, this.transformTo, this.genericAnnotations);
  
}